#!/usr/bin/env ruby
require 'studio_game/boss_player'
require 'studio_game/player'

module StudioGame
  describe BossPlayer do
    before do
      $stdout = StringIO.new
      @boss = BossPlayer.new("Bowser")
    end
    
    it { expect(BossPlayer).to be < Player }

    it "only gets half the point value for each treasure" do
      expect(@boss.points).to eq(0)

      lasergun = Treasure.new(:lasergun, 100)
      @boss.found_treasure(lasergun)
      @boss.found_treasure(lasergun)
      @boss.found_treasure(lasergun)

      expect(@boss.points).to eq(900)

      cannon = Treasure.new(:cannon, 400)
      @boss.found_treasure(cannon)
      
      expect(@boss.points).to eq(2100)    
      yielded = []
      @boss.each_found_treasure do |treasure|
        yielded << treasure 
      end

      expect(yielded).to eq([Treasure.new(:lasergun, 900), Treasure.new(:cannon, 1200)])
    end
  end
end
