require 'studio_game/game'

module StudioGame
    describe Game do
        before do
            @game = Game.new("Knuckleheads")
            @initial_health = 100
            @player = Player.new("moe", @initial_health)
            @player2 = Player.new("nick", @initial_health)
            @game.add_player(@player)
            @game.add_player(@player2)
        end

        it "has a title" do
            expect(@game.name).to eq("Knuckleheads")
        end

        it 'computes total points as the sum of all player points' do
            game = Game.new("Knuckleheads")
        
            player1 = Player.new("moe")
            player2 = Player.new("larry")
        
            game.add_player(player1)
            game.add_player(player2)
        
            player1.found_treasure(Treasure.new(:hammer, 50))
            player1.found_treasure(Treasure.new(:hammer, 50))
            player2.found_treasure(Treasure.new(:crowbar, 400))
            
            expect(game.total_points).to eq(500)
        end
    end
end