#!/usr/bin/env ruby
require 'studio_game/super_boss_player'
require 'studio_game/player'


module StudioGame
  describe SuperBossPlayer do
    before do
      $stdout = StringIO.new
      @superboss = SuperBossPlayer.new("Bowser")
    end
    
    it { expect(SuperBossPlayer).to be < Player }
    it { expect(SuperBossPlayer).to be < Player}

    it "only gets half the point value for each treasure" do
      expect(@superboss.points).to eq(0)

      lasergun = Treasure.new(:lasergun, 10)
      @superboss.found_treasure(lasergun)
      @superboss.found_treasure(lasergun)
      @superboss.found_treasure(lasergun)

      expect(@superboss.points).to eq(30000)

      cannon = Treasure.new(:cannon, 100)
      @superboss.found_treasure(cannon)
      
      expect(@superboss.points).to eq(130000)    
      yielded = []
      @superboss.each_found_treasure do |treasure|
        yielded << treasure 
      end

      expect(yielded).to eq([Treasure.new(:lasergun, 30000), Treasure.new(:cannon, 100000)])
    end

    it 'should w00t if blammed in berserk mode' do
      6.times {@superboss.w00t}
      expect(@superboss.health).to eq(190)
      2.times {@superboss.blam}
      expect(@superboss.health).to eq(220)
    end

    it 'superboss should go berserk after 5 w00ts' do
      expect(@superboss.berserk?).to eq(false)
      5.times{@superboss.w00t}
      expect(@superboss.berserk?).to eq(true)
    end
  end
end
