require 'studio_game/treasure_trove'

module StudioGame
    describe Treasure do 
        before do 
            @treasure = Treasure.new(:hammer, 50)
        end

        it 'has a name attribute' do
            expect(@treasure.name).to eq(:hammer)
        end

        it 'has a points attribute' do 
            expect(@treasure.points).to eq(50)
        end
    end

    describe TreasureTrove do
        before do 
            @treasures = TreasureTrove::TREASURES
        end

        it 'has a trove of 4' do 
            expect(@treasures.length).to eq(4)
        end
        it 'has gold worth 200' do 
            expect(@treasures[0].name).to eq(:Gold)
            expect(@treasures[0].points).to eq(200)
        end
        it 'has silver worth 150' do 
            expect(@treasures[1].name).to eq(:Silver)
            expect(@treasures[1].points).to eq(150)
        end
        it 'has bronze worth 100' do 
            expect(@treasures[2].name).to eq(:Bronze)
            expect(@treasures[2].points).to eq(100)
        end
        it 'has platinum worth 1000' do
            expect(@treasures[3].name).to eq(:Platinum)
            expect(@treasures[3].points).to eq(1000)
        end
    end
end